"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

ProxyMethodMethodInvocationNode subclass:#ProxyMethodJavaMethodInvocationNode
	instanceVariableNames:'descriptor'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Experiments-Support'
!

!ProxyMethodJavaMethodInvocationNode class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
! !

!ProxyMethodJavaMethodInvocationNode methodsFor:'accessing'!

descriptor
    ^ descriptor
!

descriptor:aJavaMethodDescriptor
    descriptor := aJavaMethodDescriptor.
!

method:aMethod

    super method: aMethod.
    method isJavaMethod ifTrue:[
        descriptor := method descriptor
    ].

    "Created: / 16-12-2011 / 00:26:32 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!ProxyMethodJavaMethodInvocationNode methodsFor:'evaluation'!

evaluateWithReceiver: receiver arguments:args

    | retval |
    args size == descriptor numPhysicalArgs ifTrue:[
        retval := super evaluateWithReceiver: receiver arguments:args.
    ] ifFalse:[
        self error:'Not yet implemented, should care about doubles and longs'.
        ^nil
    ].

    ^descriptor return javaClass javaUnwrap: retval

    "Created: / 10-12-2011 / 19:46:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

generate: compiler

    | invocation |

    compiler args size == descriptor numPhysicalArgs ifFalse:[
        self error:'Not yet implemented, should care about doubles and longs'.
        ^nil
    ].

    method programmingLanguage isJava ifTrue:[    
        | returnType |

        returnType := descriptor return javaClass.

        method isStatic ifFalse:[
            "Instance method..."    
            invocation := super generate: compiler.
        ] ifTrue:[
            "Static method, user invokeWithReceiver:arguments"
            invocation := MessageNode
                            receiver: (ConstantNode value: method)
                            selector: #valueWithReceiver:arguments:
                            args: { ConstantNode value: method javaClass . compiler argsArray }
        ].

        returnType isJavaWrapperClass ifTrue:[
            invocation := MessageNode
                receiver: (ConstantNode value: returnType)
                selector: #javaUnwrap:
                arg: invocation
        ] ifFalse:[returnType == Boolean ifTrue:[
            "Special hack for booleans, as they are represented as
             int in {0,1}"
             invocation := MessageNode
                receiver: invocation
                selector: #==
                arg: (ConstantNode value: 1).
        ]].

        ^invocation
    ].
    method programmingLanguage isSmalltalk ifTrue:[
        invocation :=
            MessageNode
                receiver: (ConstantNode value: descriptor return javaClass)
                selector: #javaWrap:
                arg: (super generate: compiler). 
        ^invocation
    ].
    ^self error:'Unknown programming language'.
    




    "
    | retval |
    args size == descriptor numPhysicalArgs ifTrue:[
        retval := super evaluateWithReceiver: receiver arguments:args.
    ] ifFalse:[
        self error:'Not yet implemented, should care about doubles and longs'.
        ^nil
    ].

    ^descriptor return javaClass javaUnwrap: retval
    "

    "Created: / 22-12-2011 / 09:27:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 30-12-2011 / 15:20:08 / kursjan <kursjan@fit.cvut.cz>"
    "Modified (comment): / 03-01-2012 / 21:18:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!ProxyMethodJavaMethodInvocationNode methodsFor:'testing'!

isProxyMethodJavaMethodInvocationNode
    ^ true
! !

!ProxyMethodJavaMethodInvocationNode class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
