"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

LibraryDefinition subclass:#stx_libjava_experiments
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_libjava_experiments class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
!

extensionsVersion_SVN
    ^ '$Id$'
! !

!stx_libjava_experiments class methodsFor:'description'!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'stx:goodies/sunit'
        #'stx:libbasic'    "Collection - superclass of SetSample "
        #'stx:libcomp'    "ByteCodeCompiler - superclass of IndirectInstvarAccessCompiler "
        #'stx:libjava'    "Java - superclass of JavaMethodWrapperCompiler "
        #'stx:libview'    "Color - referenced by ProxyMethod>>printStringForBrowserWithSelector:inClass: "
    )
! !

!stx_libjava_experiments class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        NoReflectionObject
        #'stx_libjava_experiments'
        JavaLookup
        JavaMethodWrapperCompiler
        (LookupIntegrationTests autoload)
        (LookupIntegrationTestsResource autoload)
        (LookupTests autoload)
        PersonSample
        SampleHandler
        SetSample
        ProxyMethod
        ProxyMethodNode
        ProxyMethodConditionNode
        ProxyMethodGuardNode
        ProxyMethodInvocationNode
        ProxyMethodAndNode
        ProxyMethodBlockInvocationNode
        ProxyMethodMethodInvocationNode
        ProxyMethodTypeCheckNode
        ProxyMethodJavaMethodInvocationNode
        ProxyMethodCompiler
        ProxyMethodJavaTypeCheckNode
        (#'Benchmarks::JavaLookup' autoload)
        ToObject
        (STCIndirectInstvarAccessTest autoload)
        STCIndirectInstvarAccessTestSample
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        Class box:toType:
        Class unbox:to:
        JavaStringBox box:
        JavaStringBox unbox:
        JavaTypeBox box:
        JavaTypeBox initialize
        JavaTypeBox javaMessageToSmalltalk:
        JavaTypeBox javaType
        JavaTypeBox smalltalkType
        JavaTypeBox unbox:
        VoidBox box:
        VoidBox unbox:
        JavaMethodDescriptor guardCondition
        Class perform:onReceiver:from:ifNotFound:
        JavaClass doesNotUnderstand:
        JavaClass lookupMethodFor:
        JavaClass performStatic:
        JavaClass performStatic:with:
        JavaObject doesNotUnderstand:
        JavaClass javaWrappedClass
    )
! !

!stx_libjava_experiments class methodsFor:'description - java'!

javaClassPath

    <javaclasspath>

    ^{ 
        self packageDirectory / 'java' / 'bin' .
        self packageDirectory / 'java' / 'libs' / '*.jar' 
    }

    "Created: / 17-11-2011 / 23:00:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

javaSourcePath

    <javasourcepath>

    ^{ 
        self packageDirectory / 'java' / 'src' .
    }

    "Created: / 17-11-2011 / 23:01:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libjava_experiments class methodsFor:'description - svn'!

svnRepositoryUrlString
    "Return a SVN repository URL of myself.
     (Generated since 2011-04-08)
    "        

    ^ '$URL$'
!

svnRevisionNr
    "Return a SVN revision number of myself.
     This number is updated after a commit"

    ^ "$SVN-Revision:"        '1705M'"$"
! !

!stx_libjava_experiments class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
