"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger

 New code and modifications done at SWING Research Group [1]:

 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 [1] Code written at SWING Research Group contains a signature
     of one of the above copright owners. For exact set of such code,
     see the differences between this version and version stx:libjava
     as of 1.9.2010
"
"{ Package: 'stx:libjava' }"

LibraryDefinition subclass:#stx_libjava
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!

!stx_libjava class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger

 New code and modifications done at SWING Research Group [1]:

 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 [1] Code written at SWING Research Group contains a signature
     of one of the above copright owners. For exact set of such code,
     see the differences between this version and version stx:libjava
     as of 1.9.2010

"
!

extensionsVersion_SVN
    ^ '$Id$'
! !

!stx_libjava class methodsFor:'accessing'!

svnRepositoryUrl

    ^'https://jv@swing.fit.cvut.cz/svn/stx/libjava/branches/jk_new_structure/src'

!

svnRepositoryUrlBase

    | url |
    url := stx_libjava svnRepositoryUrl.
    url ifNil:[url := 'https://swing.fit.cvut.cz/svn/stx/libjava/trunk/src'].
    (url endsWith: 'src') ifTrue:[url := url copyTo: url size - 4].
    ^url

    "Created: / 08-04-2011 / 16:57:37 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libjava class methodsFor:'accessing - tests'!

excludedFromTestSuite  
    "List of testcases and/or tests excluded from testsuite.
     Entries maybe ClassName or #(ClassName testName)
    "
    ^ #(
        LookupTests
    )

    "Created: / 03-06-2011 / 17:04:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

testSuite

    | suite javaTestCases stTests |
    suite := super testSuite.
        stTests := suite tests.
    suite := TestSuite new.
    suite name: self package.
    JavaTestsLoader load.

    javaTestCases := OrderedCollection new.

    Java allClassesDo:
        [:jclass|
        (jclass ~~ (Java at:'stx.libjava.tests.JUnit3Tests')
            and:[jclass ~~ (Java at:'stx.libjava.tests.JUnit4Tests')
                and:[jclass isTestCaseLike]])
                    ifTrue:
                        [ | tc |
                        tc := jclass asTestCase.
                                                (tc askFor:#isTestlet) ifTrue:[
                                                      tc shouldFork: true.
                                                ].
                        tc isAbstract ifFalse:[javaTestCases add:tc ]]].

    javaTestCases do:
                [:each | 
                suite addTests:each buildSuite tests ].


    suite tests addAll: stTests.

    suite tests withIndexDo:
        [:t :i|
        Stdout nextPutAll: i printString; space; nextPutAll: t printString; cr].

    ^suite

    "
        stx_libjava testSuite

    "

    "Created: / 07-05-2011 / 19:58:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 04-06-2011 / 17:23:05 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 22-12-2011 / 09:55:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

testSuiteWithoutJavaTests

    ^super testSuite.

    "Created: / 21-06-2011 / 17:33:46 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libjava class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
    )
!

preRequisites
    "list all required packages.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies and looking for
     global variable accesses. (the browser has a menu function for that)
     Howevery, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPrerequisites method."

    ^ #(
        #'squeak:petitparser'    "PPCompositeParser - superclass of JavaPetitParser "
        #'stx:goodies/sunit'    "TestCase - superclass of JavaTestCaseProxy "
        #'stx:libbasic'    "Class - superclass of JavaClass "
        #'stx:libbasic2'    "BitArray - superclass of extended BooleanArray "
        #'stx:libbasic3'    "MessageTracer - referenced by JavaMethod>>setBreakPoint "
        #'stx:libcomp'    "ObjectFileLoader - referenced by JavaVM class>>_Runtime_loadFileInternalI: "
        #'stx:libhtml'    "URL - referenced by JavaEmbeddedFrameView>>setupAppletFrameIn:initializeJava: "
        #'stx:libtool'    "WorkspaceApplication - referenced by JavaEvaluator>>evaluate:in:receiver:notifying:logged:ifFail: "
        #'stx:libview'    "TopView - superclass of JavaTopView "
        #'stx:libview2'    "Plug - referenced by JavaSourceCodeCache>>findMethodLine:inMethods: "
        #'stx:libwidg'    "Button - referenced by JavaVM class>>_WButtonPeer_create: "
        #'stx:libwidg2'    "CheckBox - referenced by JavaVM class>>_WCheckboxPeer_create: "
    )
! !

!stx_libjava class methodsFor:'description - compilation'!

additionalLinkLibraries_bc_dot_mak

    ^ '$(ZLIB_DIR)\$(ZLIB) support\fdlibm\libfdm.lib'

    "Modified: / 07-09-2011 / 17:04:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalLinkLibraries_make_dot_proto

    ^ '$(ZLIB_LD_ARG) support/fdlibm/libfdm.a'

    "Modified: / 07-09-2011 / 17:01:57 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalRules_bc_dot_mak
    ^ '
$(ZLIB):
        cd $(ZLIB_DIR)
        $(MAKE) $(MAKE_ZLIB_ARG) $(ZLIB)
        cd ..\..\libjava

$(BZ2LIB):
        cd $(BZ2LIB_DIR)
        $(MAKE) $(MAKE_BZ2LIB_ARG) bz2.lib
        cd ..\..\libjava

support\fdlibm\libfdm.lib:
        cd support\fdlibm
        $(MAKE) -f Makefile.bcc
        cd ..\..

'

    "Modified: / 07-09-2011 / 17:04:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalRules_make_dot_proto
    ^ '
zlib:
        cd $(ZLIB_DIR); $(MAKE) $(MAKE_ZLIB_ARG)

support/fdlibm/libfdm.a:
        $(MAKE) -C support/fdlibm

'

    "Modified: / 07-09-2011 / 17:01:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalTargets_bc_dot_mak

    ^ '$(ZLIB) support\fdlibm\libfdm.lib'

    "Modified: / 07-09-2011 / 17:03:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

additionalTargets_make_dot_proto

    ^ ' zlib support/fdlibm/libfdm.a'

    "Created: / 05-09-2006 / 16:05:12 / cg"
    "Modified: / 07-09-2011 / 17:00:12 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

localIncludes
    ^ '-I$(ZLIB_DIR) -Isupport/fdlibm'

    "Created: / 06-09-2006 / 18:18:15 / cg"
    "Modified: / 07-09-2011 / 17:03:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libjava class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        (AbstractJavaTestCase autoload)
        (JUnitTestCaseProxy autoload)
        Java
        JavaAnnotation
        JavaAnnotationContainer
        JavaAnnotationDefault
        JavaAnnotationDictionary
        JavaAnnotationValue
        (JavaAntProjectResource autoload)
        JavaArray
        JavaByte
        (JavaByteCodeDisassemblerTests autoload)
        (JavaByteCodeInterpreterTests autoload)
        JavaByteCodeProcessor
        (JavaByteCodeProcessorTests autoload)
        (JavaClassLoadingTests autoload)
        (JavaClassReader2Tests autoload)
        (JavaClassReaderTests autoload)
        (JavaClassRefTests autoload)
        JavaClassRegistry
        JavaConstantPool
        JavaConstants
        JavaContext
        JavaDecompiler
        JavaDescriptor
        JavaError
        JavaEvaluator
        JavaExceptionTableEntry
        (JavaExceptionThrowerMock autoload)
        JavaField
        (JavaFieldRefTests autoload)
        (JavaFreshlyInitializedResource autoload)
        (JavaInitializedResource autoload)
        (JavaInterfaceMethodRefTests autoload)
        (JavaJUnitTests autoload)
        JavaJavadocNode
        JavaLanguage
        JavaLibraries
        (JavaLibrariesResource autoload)
        JavaLocalVariableTable
        JavaLocalVariableTableEntry
        JavaMathSupport
        (JavaMethodRefTests autoload)
        JavaMonitor
        (JavaMonitorsTests autoload)
        JavaNameAndType2
        JavaNativeMemory
        JavaNode
        JavaObject
        JavaObjectDictionary
        JavaPackage
        JavaParseResult
        (JavaParserNavigationTests autoload)
        (JavaParserTestCase autoload)
        (JavaParserTests autoload)
        JavaPopUpView
        JavaProcess
        JavaRef2
        (JavaRefMock autoload)
        (JavaRefTests autoload)
        JavaRelease
        JavaResolver
        (JavaRuntimeConstantPoolTests autoload)
        JavaShort
        JavaSlotIndexCache
        JavaSocket
        JavaSourceCodeCache
        JavaSourceFileWriter
        JavaStartup
        (JavaTestCaseProxy autoload)
        JavaTestsLoader
        (JavaTestsResource autoload)
        JavaTopView
        (JavaUTF8Tests autoload)
        JavaUnresolvedConstant
        JavaView
        JavaZipSupport
        (LookupIntegrationTests autoload)
        (LookupIntegrationTestsResource autoload)
        (MPXJTests autoload)
        PPJavaNode
        SmalltalkAppletContext
        SmalltalkAppletStub
        (TestletTestCaseProxy autoload)
        #'stx_libjava'
        JavaAnnotationArrayValue
        JavaAnnotationClassValue
        JavaAnnotationEnumValue
        JavaAnnotationNestedAnnotationValue
        JavaAnnotationPrimitiveValue
        JavaBehavior
        JavaByteCodeDisassembler
        JavaByteCodeEnumerator
        JavaByteCodeInterpreter
        JavaClassAnnotationContainer
        JavaClassContentRef2
        JavaClassReader
        JavaClassRef2
        JavaEmbeddedFrameView
        JavaFieldAnnotationContainer
        JavaFieldDescriptor
        JavaFormalParameterNode
        JavaInvalidRefError
        JavaMethod
        JavaMethodAnnotationContainer
        JavaMethodDeclarationNode
        JavaMethodDeclaratorNode
        JavaMethodDescriptor
        JavaMethodNode
        JavaPetitParser
        JavaStringRef2
        JavaTypeNode
        JavaUnhandledExceptionError
        JavaUnresolvedClassConstant
        JavaUnresolvedStringConstant
        JavaVM
        JavadocDeclarationNode
        JavaArrayTypeNode
        JavaBooleanTypeNode
        JavaBothOldAndNewClassRef
        JavaByteCodeSteppableInterpreter
        JavaCharTypeNode
        JavaClass
        JavaClassOrInterfaceTypeNode
        JavaDoubleTypeNode
        JavaFieldRef2
        JavaFloatTypeNode
        JavaIntTypeNode
        JavaLongTypeNode
        JavaMethodRef2
        JavaMethodWithException
        JavaVoidTypeNode
        JavaInterfaceMethodRef2
        JavaMethodWithHandler
        JavaNativeMethod
        JavaUtilities
        JavaFieldDescriptorWithUnionType
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
        BooleanArray isInterface
        CharacterArray asDottedJavaClassName
        CharacterArray asInternalJavaClassName
        CharacterArray asJavaComponentClassName
        CharacterArray asJavaishClassName
        CharacterArray asNiceJavaClassName
        CharacterArray asSTXInternalJavaClassName
        CharacterArray asSlashedJavaClassName
        CharacterArray isJavaArrayDescriptor
        CharacterArray isJavaPrimitiveTypeDescriptor
        Class perform:onReceiver:from:ifNotFound:
        Delay waitWithState:
        Object isJavaArray
        Object isJavaNameAndType
        Object isJavaPackage
        Object isJavaRef
        Object javaBox:
        Process clearInterrupted
        Process isInterrupted
        Process isSleeping
        Process isWaiting
        Process javaInterrupt
        Process setInterrupted
        Set #'java__contains:'
        String asArrayOfSubstringsSeparatedBy:
        UserPreferences javaTestsDirectory
        UserPreferences javaTestsDirectory:
        ZipArchive nextBytes:of:startingAt:into:startingAt:
        'Boolean class' isJavaPrimitiveType
        'Boolean class' javaArrayClass
        'Boolean class' javaBox:
        'Boolean class' javaName
        'Boolean class' javaUnbox:onError:
        'BooleanArray class' isInterface
        'BooleanArray class' isJavaArrayClass
        'BooleanArray class' isJavaReferenceType
        'BooleanArray class' javaComponentClass
        'BooleanArray class' javaName
        'ByteArray class' isInterface
        'ByteArray class' isJavaArrayClass
        'ByteArray class' isJavaReferenceType
        'ByteArray class' javaArrayClass
        'ByteArray class' javaComponentClass
        'ByteArray class' javaName
        'Character class' isJavaPrimitiveType
        'Character class' javaArrayClass
        'Character class' javaBox:
        'Character class' javaName
        'Character class' javaUnbox:onError:
        'CharacterArray class' decodeFromJavaUTF8:
        'CharacterArray class' fromJavaUTF8Bytes:
        'CharacterArray class' isJavaArrayClass
        'CharacterArray class' javaArrayClass
        'CharacterArray class' javaComponentClass
        'DoubleArray class' isInterface
        'DoubleArray class' isJavaArrayClass
        'DoubleArray class' isJavaReferenceType
        'DoubleArray class' javaComponentClass
        'DoubleArray class' javaName
        'Float class' isJavaPrimitiveType
        'Float class' javaArrayClass
        'Float class' javaBox:
        'Float class' javaName
        'FloatArray class' isInterface
        'FloatArray class' isJavaArrayClass
        'FloatArray class' isJavaReferenceType
        'FloatArray class' javaComponentClass
        'FloatArray class' javaName
        'GenericToolbarIconLibrary class' javaClassBrowserIcon
        'GenericToolbarIconLibrary class' javaExceptionBrowserIcon
        'GenericToolbarIconLibrary class' javaPrivateClassBrowserIcon
        'GenericToolbarIconLibrary class' javaPrivateEnumBrowserIcon
        'GenericToolbarIconLibrary class' javaPrivateInterfaceBrowserIcon
        'GenericToolbarIconLibrary class' javaProtectedClassBrowserIcon
        'GenericToolbarIconLibrary class' javaProtectedEnumBrowserIcon
        'GenericToolbarIconLibrary class' javaProtectedInterfaceBrowserIcon
        'GenericToolbarIconLibrary class' javaPublicClassBrowserIcon
        'GenericToolbarIconLibrary class' javaPublicEnumBrowserIcon
        'GenericToolbarIconLibrary class' javaPublicInterfaceBrowserIcon
        'GenericToolbarIconLibrary class' javaRuntimeExceptionBrowserIcon
        'Integer class' isJavaPrimitiveType
        'Integer class' javaArrayClass
        'Integer class' javaBox:
        'Integer class' javaName
        'Integer class' javaUnbox:onError:
        'Integer class' javaUnbox:onError:min:max:
        'LargeInteger class' isJavaPrimitiveType
        'LargeInteger class' javaArrayClass
        'LargeInteger class' javaBox:
        'LargeInteger class' javaName
        'LargeInteger class' javaUnbox:onError:
        'Object class' isJavaArrayClass
        'Object class' isJavaClassType
        'Object class' isJavaPrimitiveType
        'Object class' isJavaReferenceType
        'Object class' isJavaType
        'ShortFloat class' isJavaPrimitiveType
        'ShortFloat class' javaArrayClass
        'ShortFloat class' javaBox:
        'ShortFloat class' javaName
        'SignedIntegerArray class' isInterface
        'SignedIntegerArray class' isJavaArrayClass
        'SignedIntegerArray class' javaArrayClass
        'SignedIntegerArray class' javaComponentClass
        'SignedIntegerArray class' javaName
        'SignedLongIntegerArray class' isInterface
        'SignedLongIntegerArray class' isJavaArrayClass
        'SignedLongIntegerArray class' isJavaReferenceType
        'SignedLongIntegerArray class' javaArrayClass
        'SignedLongIntegerArray class' javaComponentClass
        'SignedLongIntegerArray class' javaName
        'UndefinedObject class' isJavaPrimitiveType
        'UndefinedObject class' javaName
        'WordArray class' isInterface
        'WordArray class' isJavaArrayClass
        'WordArray class' isJavaReferenceType
        'WordArray class' javaArrayClass
        'WordArray class' javaComponentClass
        'WordArray class' javaName
        WrappedMethod isAbstract
        'BooleanArray class' javaArrayClass
        'DoubleArray class' javaArrayClass
        'FloatArray class' javaArrayClass
        Object javaUnwrap:
        'Boolean class' javaUnwrap:
        'ProjectDefinition class' javaClassPath
        'ProjectDefinition class' javaSourcePath
        WrappedMethod descriptor
        Object javaWrap:
        Object isJavaWrapperClass
        Object javaUnwrapFrom:
        SmallInteger javaUnwrapFrom:
    )
! !

!stx_libjava class methodsFor:'description - java'!

javaClassPath

    "Defines a Java class path containing java classes/jars
     required by this package"

     <javaclasspath>

     ^{ 
         self packageDirectory / 'java' / 'libjava-projects' / 'Conversion' / 'bin' .
         self packageDirectory / 'java' / 'libjava-support' / 'bin' .
         self packageDirectory / 'java' / 'libs' / '*.jar' 
     }

    "Created: / 14-12-2011 / 00:12:24 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

javaSourcePath

     <javasourcepath>

     ^{ 
         self packageDirectory / 'java' / 'libjava-projects' / 'Conversion' / 'src' .
         self packageDirectory / 'java' / 'libjava-support' / 'src' .
     }

    "Created: / 14-12-2011 / 00:13:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libjava class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Description string which will appear in vc.def / bc.def"

    ^ 'Smalltalk/X Class library'
!

legalCopyright
    "Copyright string which will appear in <lib>.rc"

    ^ 'Copyright Claus Gittinger 1988-2011\nCopyright eXept Software AG 1998-2011\nCopyright Jan Vrany, Jan Kurs and Marcel Hlopko\b          SWING Research Group, Czech Technical University In Prague'

    "Modified: / 26-07-2011 / 17:13:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

productName
    "Return product name which will appear in <lib>.rc"

    ^ 'Smalltalk/X'
! !

!stx_libjava class methodsFor:'description - svn'!

svnRepositoryUrlString
    "return a SVN repository URL of myself.
     (Generated since 2011-04-08)
    "        

    ^ '$URL$'
!

svnRevisionNr
    "Return a SVN revision number of myself.
     This number is updated after a commit"

    ^ "$SVN-Revision:"        '1689M'"$"
! !

!stx_libjava class methodsFor:'file generation'!

basicFileNamesToGenerat
    "answer a dictionary (filename -> generator method) with all the files, that have to be generated for this
     package"

    |dict|

    dict := super basicFileNamesToGenerate.

    dict 
        at:'builder/package.deps.rake' put: #'generate_package_dot_deps_dot_rake'.

    ^ dict.

    "Created: / 11-03-2011 / 09:32:01 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libjava class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
